﻿package common
{
	import flash.display.Sprite;
	import flash.display.Stage;
	
	public class AppInfo
	{
		private static var root:Sprite;
		private static var stage:Stage;
		
		private static var fps:FPS = null;
		
		public static function registerMainSprite(sprite:Sprite):void
		{
			root = sprite;
			stage = sprite.stage;
			return;
		}
		
		// --------------------------------//
		// プロパティ
		// --------------------------------//
		public static function set frameRate(num:Number):void {stage.frameRate = num;}
		public static function get frameRate():Number {return stage.frameRate;}
		
		public static function viewFPS():void
		{
			if(fps != null) {return;}
			
			fps = new FPS();
			root.addChild(fps);
		}
		
		public static function hideFPS():void
		{
			if(fps == null) {return;}
			
			root.removeChild(fps);
			fps = null;
		}
		
		public static var frameSkip:Boolean = false;
	}
}

import flash.display.Bitmap;
import flash.events.Event;
import flash.utils.setInterval;
import flash.display.BitmapData;

class FPS extends Bitmap
{
	private var bmp:BitmapData = new BitmapData(8*8, 8, true, 0);
	private var count:int = 0;
	
	public function FPS()
	{
		func_text.draw("SYSTEM", bmp, "FPS = ", 0, 0);
		bitmapData = bmp;
		
		x = y = 2;
		scaleX = scaleY = 2;
		
		addEventListener(Event.ENTER_FRAME, onEnterFrame);
		setInterval(update, 1000);
	}
	
	private function onEnterFrame(event:Event):void
	{
		count++;
	}
	
	private function update():void
	{
		func_text.draw("SYSTEM", bmp, "FPS = "+count, 0, 0);
		count = 0;
	}
}