package common
{
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	
	public class BitmapFont
	{
		private var chip:Object = new Object();
		private var chipheight:int;
		private var chipset:BitmapData;
		private var chipxnum:int;
		private var chipynum:int;
		private var chipset2:BitmapData;
		private var chipxnum2:int;
		private var chipynum2:int;
		
		public function BitmapFont(
			bmp:BitmapData, texttable:String, width:int, height:int,
			bmp2:BitmapData = null, texttable2:String = null, width2:int = 0)
		{
			chipheight = height;
			
			chipset = bmp;
			
			chipxnum = chipset.width/width;
			chipynum = chipset.height/height;
			
			for(var i:int = 0; i < texttable.length; i++)
			{
				chip[texttable.charAt(i)] = {
					bmp : chipset,
					width : width,
					rect : new Rectangle(width*(i % chipxnum), height*(Math.floor(i / chipxnum)), width, height)
				};
			}
			
			//２番目
			if(bmp2 != null)
			{
				chipset2 = bmp2;
				
				chipxnum2 = chipset2.width/width2;
				chipynum2 = chipset2.height/height;
				
				for(var i:int = 0; i < texttable2.length; i++)
				{
					chip[texttable2.charAt(i)] = {
						bmp : chipset2,
						width : width2,
						rect : new Rectangle(width2*(i % chipxnum2), height*(Math.floor(i / chipxnum2)), width2, height)
					};
				}
			}
		}
		
		// --------------------------------//
		// 文字列描画
		// --------------------------------//
		public function draw(bmp:BitmapData, txt:String, x:Number, y:Number):void
		{
			var px:Number = x;
			
			for(var i:int = 0; i < txt.length; i++)
			{
				var char:String = txt.charAt(i);
				if(char === "\n")
				{
					y += chipheight;
					x = px;
				}
				else
				{
					bmp.copyPixels(chip[char].bmp, chip[char].rect, new Point(x, y));
					x += chip[char].width;
				}
			}
			
			return;
		}
		
		// --------------------------------//
		// 文字列の幅を取得
		// --------------------------------//
		public function getTextWidth(txt:String):int
		{
			var width:int = 0;
			var max:int = 0;
			
			for(var i:int = 0; i < txt.length; i++)
			{
				var char:String = txt.charAt(i);
				if(char === "\n")
				{
					max = width;
					width = 0;
				}
				else
				{
					width += chip[char].width;
				}
			}
			
			return Math.max(width, max);
		}
		
		// --------------------------------//
		// 文字列の高さを取得
		// --------------------------------//
		public function getTextHeight(txt:String):int
		{
			var height:int = chipheight;
			
			for(var i:int = 0; i < txt.length; i++)
			{
				var char:String = txt.charAt(i);
				if(char === "\n")
				{
					height += chipheight;
				}
			}
			
			return height;
		}
	}
}