package common
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.display.Stage;
	import flash.display.StageQuality;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.PixelSnapping;
	import flash.utils.getTimer;
	
	public class Framework
	{
		private var root:Sprite;
		private var stage:Stage;
		public var screen:Screen;
		private var mainloop:Function;
		
		public function Framework(sprite:Sprite, func:Function, width:uint, height:uint)
		{
			root = sprite;
			stage = sprite.stage;
			stage.quality = StageQuality.LOW;
			mainloop = func;
			
			AppInfo.registerMainSprite(root);
			
			//入力
			Key.setListener(root);
			Mouse.setListener(stage);
			
			//画面
			var bmp:Bitmap = new Bitmap(new BitmapData(width, height, false, 0x008080), PixelSnapping.ALWAYS, false);
			root.addChild(bmp);
			screen = new Screen(bmp);
			
			root.addEventListener(Event.ENTER_FRAME, onEnterFrame);
			return;
		}
		
		// --------------------------------//
		// メインループ
		// --------------------------------//
		private var timer:Number = 0;
		private function onEnterFrame(event:Event):void
		{
			if(stage.focus == null)
			{
				Key.clear();	//キーを押しながらフォーカスを外すと押しっぱなしになる現象の対策
				stage.focus = root;
			}
			
			if(AppInfo.frameSkip == true)
			{
				for(; timer < getTimer(); timer += 1000 / 45) {
					main();
				}
			}
			else {
				if(timer < getTimer())
				{
					timer += 1000 / 45;
					main();
				}
			}
			
			if(getTimer() - timer > 200) {
				timer = getTimer();
			}
			
			return;
		}
		
		private function main():void
		{
			Mouse.main();
			
			screen.buffer.lock();
			mainloop();
			screen.buffer.unlock();
			
			func_bgm.main();
			func_se.main();
		}
	}
}