package common
{
	import flash.utils.Proxy;
	import flash.utils.flash_proxy;
	import flash.utils.Dictionary;
	import flash.utils.ByteArray;
	
	public class List extends Proxy
	{
		private var dict:Dictionary = new Dictionary();
		public var length:uint = 0;
		
		public function List()
		{
			dict["head"] = new ListElem();
			dict["tail"] = new ListElem();
			
			dict["head"]._prev = null;
			dict["head"]._next = dict["tail"];
			dict["tail"]._prev = dict["head"];
			dict["tail"]._next = null;
		}
		
		// --------------------------------//
		// 要素の操作
		// --------------------------------//
		public function push(key:*):void
		{
			var tail:ListElem = dict["tail"];
			var elem:ListElem = new ListElem();
			elem.item = key;
			
			//つなぎかえ
			elem._next = tail;
			elem._prev = tail._prev;
			tail._prev._next = elem;
			tail._prev       = elem;
			
			dict[key] = elem;
			length++;
			return;
		}
		
		public function insert(index:*, key:*):void
		{
			var temp:ListElem = dict[index];
			var elem:ListElem = new ListElem();
			elem.item = key;
			
			//つなぎかえ
			elem._next = temp;
			elem._prev = temp._prev;
			temp._prev._next = elem;
			temp._prev       = elem;
			
			dict[key] = elem;
			length++;
			return;
		}
		
		public function erase(key:*):void
		{
			var elem:ListElem = dict[key];
			
			//つなぎかえ
			elem._prev._next = elem._next;
			elem._next._prev = elem._prev;
			
			length--;
			return;
		}
		
		public function clone():List
		{
			var bin:ByteArray = new ByteArray();
			bin.writeObject(this);
			bin.position = 0;
			return bin.readObject();
		}
		
		// --------------------------------//
		// 参照
		// --------------------------------//
		public function getPrevItem(key:*):*
		{
			return dict[key]._prev;
		}
		
		public function getNextItem(key:*):*
		{
			return dict[key]._next;
		}
		
		override flash_proxy function getProperty(name:*):*
		{
			var num:Number = Number(name);
			if(isNaN(num) == false)
			{
				var elem:* = dict["head"]._next;
				for (var i:int = 0; ; i++)
				{
					if(elem.item == null) {return undefined;}
					if(i >= num) {return elem.item;}
					elem = elem._next;
				}
			}
			
			return undefined;
		}
		
		private var _props:Array;
		override flash_proxy function nextNameIndex(index:int):int
		{
			if (index == 0)
			{
				//配列にする
				_props = new Array();
				for (var elem:* = dict["head"]._next; elem._next != null; elem = elem._next) {
					_props.push(elem.item);
				}
			}
			if (index < _props.length) {return index + 1;}
			else {return 0;}
		}
		
		override flash_proxy function nextValue(index:int):*
		{
			return _props[index-1];
		}
	}
}

class ListElem
{
	public var _prev:ListElem;
	public var _next:ListElem;
	
	public var item:*;
}
