package game.obj
{
	import game.system.Graphic;
	import game.system.ObjBase;
	import game.scene.maingame.MainStage;
	import flash.display.BitmapData;
	import game.system.SceneBase;
	import game.scene.maingame.ChipInfo;
	import game.system.KeyWatcher;
	
	public class GameObject extends ObjBase
	{
		public var stage:MainStage = null;
		public var func_key:KeyWatcher = null;
		
		public var x:Number = 0;
		public var y:Number = 0;
		
		public var grp:Graphic = null;
		public var frame:String = "";
		public var invert:Boolean = false;
		public var lockscreen:Boolean = false;
		
		// --------------------------------//
		// オブジェクト操作
		// --------------------------------//
		public function createObject(instance:GameObject, initx:Number = 0, inity:Number = 0):*
		{
			instance.scene = scene;
			instance.stage = stage;
			instance.func_key = func_key;
			
			instance.x = x + initx;
			instance.y = y + inity;
			
			instance.init();
			return instance;
		}
		
		// --------------------------------//
		// 位置取得
		// --------------------------------//
		public function getScreenX():Number
		{
			return x - scene.getCameraX();
		}
		
		public function getScreenY():Number
		{
			return y - scene.getCameraY();
		}
		
		// --------------------------------//
		// ステージ関係
		// --------------------------------//
		public function getChipInfo(px:Number, py:Number):ChipInfo
		{
			if(Math.floor((x+px)/24) < 0){
				px = px;
			}
			var c:ChipInfo = stage.getChipInfo(Math.floor((x+px)/24), Math.floor((y+py)/24));
			if((y+py)%24 >= 12) {c.cloud = false;}
			return c;
		}
		
		// --------------------------------//
		// 画像処理
		// --------------------------------//
		public function draw(surface:BitmapData):void
		{
			if(grp == null) {return;}
			
			if(lockscreen == false) {
				grp.draw(surface, frame, getScreenX(), getScreenY(), invert);
			}
			else {
				grp.draw(surface, frame, x, y, invert);
			}
			return;
		}
	}
}