package game.obj.box
{
	import game.obj.GameObject;
	import game.scene.maingame.ChipInfo;
	import game.obj.effect.Smoke;
	import common.List;
	
	public class BoxBase extends GameObject
	{
		protected var boxtop:GameObject;
		private var active:Boolean = false;
		
		public var vx:Number = 0;
		public var vy:Number = 0;
		
		private var hit_left:Boolean;
		private var hit_right:Boolean;
		private var hit_top:Boolean;
		private var hit_bottom:Boolean;
		
		private var fly:Boolean = false;
		private var grabflag:Boolean = false;
		public var uncollidable_allowance:int = 0;
		
		public var automove_x:Number = 0;
		
		override public function main():void
		{
			if(uncollidable_allowance > 0) {uncollidable_allowance--;}
			
			move();
			super.main();
			
			return;
		}
		
		public function move():void
		{
			hit_left  = false;
			hit_right = false;
			hit_top    = false;
			hit_bottom = false;
			automove_x = 0;
			
			if(grabflag == true) {return;}
			
			if(Math.abs(vx) > Math.abs(vy))
			{
				x += vx + automove_x;
				check_merikomi_x();
				y += vy;
				check_merikomi_y();
			}
			else
			{
				y += vy;
				check_merikomi_y();
				x += vx + automove_x;
				check_merikomi_x();
			}
			return;
		}
		
		public function act_main():void
		{
			frame = "NORMAL";
			
			if(grabflag == true) {return;}
			
			if(hit_bottom == true && vx == 0 && vy == 0) {active = false;}
			else {active = true;}
			
			if(active == true)
			{
				if(count % 2 == 0) {
					frame = "FLASH";
				}
				
				if(hit_top == true)
				{
					vx /= 2;
				}
				
				if(hit_bottom == true)
				{
					if(vx > 0.25 && vx <= 7)
					{
						vx -= 0.25;
						
						if(count % 2 == 0)
						{
							playSE("SE_SUBERI");
							createObject(new Smoke(-5, Math.random()-1), 4, 9+Math.random()*3);
						}
					}
					if(vx < -0.25 && vx >= -7)
					{
						vx += 0.25;
						
						if(count % 2 == 0)
						{
							playSE("SE_SUBERI");
							createObject(new Smoke(5, Math.random()-1), -4, 9+Math.random()*3);
						}
					}
					if(vx <= 0.25 && vx >= -0.25) {vx = 0;}
				}
				else {
					fly = true;
				}
				
				if(vy < 11)
				{
					vy += 0.6;
					if(vy > 9) {vy = 9;}
				}
			}
			
			if(hit_bottom == true)
			{
				if(fly == true)
				{
					playSE("SE_BOXCHAKUCHI");
					
					createObject(new Smoke(-3, 0), -4, 9);
					createObject(new Smoke(3, 0), 3, 9);
					
					fly = false;
				}
			}
		}
		
		// --------------------------------//
		// 取得
		// --------------------------------//
		public function isActive():Boolean
		{
			return active || grabflag;
		}
		
		public function grab():void
		{
			grabflag = true;
			changeDepth("DEPTH_BOX");
			boxtop.changeDepth("DEPTH_BOX");
		}
		
		public function ungrab():void
		{
			grabflag = false;
			check_merikomi();
			boxtop.changeDepth("DEPTH_BOX_TOP");
		}
		
		// --------------------------------//
		// 当たり判定
		// --------------------------------//
		public function check_merikomi():void
		{
			if(Math.abs(vx) >= Math.abs(vy))
			{
				check_merikomi_x();
				check_merikomi_y();
			}
			else
			{
				check_merikomi_y();
				check_merikomi_x();
			}
		}
		
		public function check_merikomi_x():void
		{
			//箱判定
			var boxlist:List = scene.func_obj.searchPriority("PRIO_BOX");
			
			for each(var box:BoxBase in boxlist)
			{
				if((box.hitTest(x-12, y-7) || box.hitTest(x-12, y+11)) && vx <= 0)
				{
					x = box.x + 24;
					vx = 0;
					hit_left = true;
				}
				if((box.hitTest(x+12, y-7) || box.hitTest(x+12, y+11)) && vx >= 0)
				{
					x = box.x - 24;
					vx = 0;
					hit_right = true;
				}
			}
			
			//地形判定
			var l1:ChipInfo = getChipInfo(-12, -7);
			var l2:ChipInfo = getChipInfo(-12, 11);
			var r1:ChipInfo = getChipInfo(11, -7);
			var r2:ChipInfo = getChipInfo(11, 11);
			
			var wallhit_l:Boolean = false;
			var wallhit_r:Boolean = false;
			
			if(l1.wall || l2.wall) {wallhit_l = true;}
			if(r1.wall || r2.wall) {wallhit_r = true;}
			
			if(wallhit_l == true && wallhit_r == true)
			{
				wallhit_l = false;
				wallhit_r = false;
			}
			
			if(wallhit_l  == true && vx <= 0)
			{
				if(x < 12) {x = 12;}
				else {x += 24-((x-12)%24);}
				vx = 0;
				hit_left = true;
			}
			if(wallhit_r == true && vx >= 0)
			{
				x -= (x+12) % 24;
				vx = 0;
				hit_right = true;
			}
			
			return;
		}
		
		public function check_merikomi_y():void
		{
			//箱判定
			var boxlist:List = scene.func_obj.searchPriority("PRIO_BOX");
			
			for each(var box:BoxBase in boxlist)
			{
				if((box.hitTest(x-8, y-12) || box.hitTest(x+8, y-12)) && vy <= 0)
				{
					y = box.y + 24;
					vy = 0;
					hit_top = true;
				}
				if((box.hitTest(x-8, y+13) || box.hitTest(x+8, y+13)) && vy >= 0)
				{
					y = box.y - 24;
					vy = 0;
					hit_bottom = true;
					
					automove_x = box.automove_x;
				}
			}
			
			//地形判定
			var t1:ChipInfo = getChipInfo(-4, -12);
			var t2:ChipInfo = getChipInfo(4, -12);
			var b1:ChipInfo = getChipInfo(-8, 12);
			var b2:ChipInfo = getChipInfo(8, 12);
			
			var wallhit_t:Boolean = false;
			var wallhit_b:Boolean = false;
			
			if(t1.wall || t2.wall) {wallhit_t = true;}
			if(b1.wall || b2.wall || b1.cloud || b2.cloud) {wallhit_b = true;}
			
			if(wallhit_t == true && wallhit_b == true)
			{
				wallhit_t = false;
			}
			
			if(wallhit_t == true && vy <= 0)
			{
				y += 24-((y-12)%24);
				vy = 0;
				hit_top = true;
			}
			if(wallhit_b == true && vy >= 0)
			{
				y -= (y+12) % 24;
				vy = 0;
				automove_x = b1.automove + b2.automove;
				hit_bottom = true;
			}
			
			return;
		}
		
		public function hitTest(px:Number, py:Number):Boolean
		{
			if(grabflag == true) {return false;}
			return ((x-12 < px) && (y-12 < py) && (x+12 > px) && (y+12 > py));
		}
	}
}