package game.obj.system
{
	import game.obj.GameObject;
	import game.system.Database;
	import game.system.Graphic;
	import flash.geom.Rectangle;
	import game.obj.box.BoxBase;
	import game.obj.box.Box;
	import game.obj.effect.RectVanish;
	import common.List;
	
	public class CheckPoint extends GameObject
	{
		public var enter:Boolean = false;
		
		override public function init():void
		{
			registerObject("PRIO_CHECKPOINT", "DEPTH_WALL");
			grp = new Graphic(Database.getItem("BMP_ANMCHIPS"));
			
			//画像切り出し
			for(var i:int = 0; i < 8; i++)
			{
				grp.addFrame(i.toString(), new Rectangle(i*24, 0, 24, 24), 12, 12);
			}
			
			changeAction("act_main");
			return;
		}
		
		public function act_main():void
		{
			var boxlist:List = scene.func_obj.searchPriority("PRIO_BOX");
			var hit:Boolean = false;
			
			for each(var box:BoxBase in boxlist)
			{
				if(box is Box)
				{
					if(box.x > x-6 && box.x < x+6 && box.y == y && box.isActive() == false)
					{
						box.frame = "DARK";
						hit = true;
					}
				}
			}
			
			if(hit == true)
			{
				if(enter == false) {
					createObject(new RectVanish());
				}
				
				enter = true;
				visible = false;
			}
			else
			{
				enter = false;
				visible = true;
			}
			
			//アニメ
			frame = Math.floor(count/4 % 8).toString();
		}
	}
}