package game.obj.system
{
	import game.obj.GameObject;
	import flash.display.BitmapData;
	import flash.geom.Point;
	
	public class MenuItem extends GameObject
	{
		public var width:int;
		
		public var label:String;
		public var button:Boolean;
		public var data:Array;
		
		public var selected:Boolean = false;
		
		private var _index:int = 0;
		private var _currentdata:String = null;
		
		public function MenuItem(label:String, button:Boolean = true, data:Array = null):void
		{
			this.label = label;
			this.button = button;
			this.data = data;
			
			if(data != null) {
				_currentdata = data[0];
			}
			
			return;
		}
		
		override public function init():void
		{
			registerObject("PRIO_SYSTEM", "DEPTH_MESSAGE");
		}
		
		public function get index():int
		{
			return _index;
		}
		
		public function set index(num:int):void
		{
			_index = num;
			_currentdata = data[_index];
		}
		
		public function get currentdata():String
		{
			return _currentdata;
		}
		
		public function set currentdata(name:String):void
		{
			for(var i:int = 0; i < data.length; i++)
			{
				if(data[i] == name)
				{
					index = i;
					return;
				}
			}
		}
		
		override public function draw(surface:BitmapData):void
		{
			var x:Number = this.x;
			
			if(selected == true) {
				x += 4;
			}
			
			if(label != "")
			{
				if(selected == true) {
					func_text.draw("16x8_orange", surface, label, x, y);
				}
				else {
					func_text.draw("16x8_blue", surface, label, x, y);
				}
			}
			
			if(currentdata != null)
			{
				var textwidth:int = func_text.getTextWidth("16x8_orange", currentdata);
				
				if(selected == true) {
					func_text.draw("16x8_orange", surface, currentdata, this.x+width-textwidth, y);
				}
				else {
					func_text.draw("16x8_blue", surface, currentdata, this.x+width-textwidth, y);
				}
			}
		}
	}
}
