package game.obj.system
{
	import game.obj.GameObject;
	import game.system.Database;
	import flash.geom.Point;
	import flash.display.BitmapData;
	
	public class Tile extends GameObject
	{
		private const SCREEN_WIDTH:int = 320;
		private const SCREEN_HEIGHT:int = 240;
		
		public var repeat_x:Boolean = true;
		public var repeat_y:Boolean = true;
		public var margin_x:int = 0;
		public var margin_y:int = 0;
		public var vx:Number = 0;
		public var vy:Number = 0;
		
		public var bmp:BitmapData;
		private var depth:String;
		
		public function Tile(bmp:BitmapData, depth:String = "DEPTH_DISTANT")
		{
			this.bmp = bmp;
			this.depth = depth;
		}
		
		override public function init():void
		{
			registerObject("PRIO_SYSTEM", depth);
		}
		
		override public function draw(surface:BitmapData):void
		{
			var p:Point = new Point();
			var initx:int = x;
			var inity:int = y;
			
			if(repeat_x == true) {
				if(x > 0) {initx = x % (bmp.width+margin_x) - (bmp.width+margin_x);}
				else      {initx = x % (bmp.width+margin_x);}
			}
			if(repeat_y == true) {
				if(y > 0) {inity = y % (bmp.height+margin_y) - (bmp.height+margin_y);}
				else      {inity = y % (bmp.height+margin_y);}
			}
			
			for(p.x = initx; p.x < SCREEN_WIDTH + bmp.width; p.x += bmp.width + margin_x)
			{
				for(p.y = inity; p.y < SCREEN_HEIGHT + bmp.height; p.y += bmp.height + margin_y)
				{
					surface.copyPixels(bmp, bmp.rect, p);
					if(repeat_y == false) {break;}
				}
				if(repeat_x == false) {break;}
			}
			
			x += vx;
			y += vy;
		}
	}
}