package game.scene
{
	import game.system.SceneBase;
	import common.MultiLoader;
	import game.system.Database;
	import flash.net.LocalConnection;
	import flash.utils.getTimer;
	import common.AppInfo;
	
	public class LoadingScene extends SceneBase
	{
		private var loader:MultiLoader = new MultiLoader();
		private var loaderlist:Object = new Object();
		private var itemlist:Array = new Array();
		private var localconnection:LocalConnection = new LocalConnection();
		private var systext:String = "";
		
		override public function init():void
		{
			//読み込みテーブル
			itemlist.push({type:"BITMAP", name:"BMP_16X8TEXT_BLUE", url:"graphic/16x8text_blue.png"});
			itemlist.push({type:"BITMAP", name:"BMP_16X8TEXT_ORANGE", url:"graphic/16x8text_orange.png"});
			itemlist.push({type:"BITMAP", name:"BMP_8PXTEXT", url:"graphic/8pxtext.png"});
			itemlist.push({type:"BITMAP", name:"BMP_MESSAGE", url:"graphic/message.png"});
			itemlist.push({type:"BITMAP", name:"BMP_PLAYER", url:"graphic/player.png"});
			itemlist.push({type:"BITMAP", name:"BMP_GUIDE", url:"graphic/guide.png"});
			itemlist.push({type:"BITMAP", name:"BMP_MAPCHIP1", url:"graphic/mapchip_1.png"});
			itemlist.push({type:"BITMAP", name:"BMP_MAPCHIP2", url:"graphic/mapchip_2.png"});
			itemlist.push({type:"BITMAP", name:"BMP_ANMCHIPS", url:"graphic/anmchips.png"});
			itemlist.push({type:"BITMAP", name:"BMP_BOX", url:"graphic/box.png"});
			itemlist.push({type:"BITMAP", name:"BMP_EFFECT", url:"graphic/effect.png"});
			itemlist.push({type:"BITMAP", name:"BMP_MENUBG", url:"graphic/menubg.png"});
			itemlist.push({type:"BITMAP", name:"BMP_DISTANT", url:"graphic/distant.png"});
			itemlist.push({type:"BITMAP", name:"BMP_TITLE", url:"graphic/title.png"});
			itemlist.push({type:"BITMAP", name:"BMP_COURSE", url:"graphic/course.png"});
			itemlist.push({type:"BITMAP", name:"BMP_BOXTILE", url:"graphic/boxtile.png"});
			itemlist.push({type:"BITMAP", name:"BMP_RATING", url:"graphic/rating.png"});
			itemlist.push({type:"BITMAP", name:"BMP_ARROW", url:"graphic/arrow.png"});
			itemlist.push({type:"BINARY", name:"DAT_STAGE", url:"stage.dat"});
			itemlist.push({type:"SWF", name:"SWF_BGMLIBRARY", url:"bgm.swf"});
			itemlist.push({type:"SOUND", name:"SE_PAUSE", url:"se/pause.mp3"});
			itemlist.push({type:"SOUND", name:"SE_SELECT", url:"se/select.mp3"});
			itemlist.push({type:"SOUND", name:"SE_ENTER", url:"se/enter.mp3"});
			itemlist.push({type:"SOUND", name:"SE_CANCEL", url:"se/cancel.mp3"});
			itemlist.push({type:"SOUND", name:"SE_START", url:"se/start.mp3"});
			itemlist.push({type:"SOUND", name:"SE_CHAKUCHI", url:"se/chakuchi.mp3"});
			itemlist.push({type:"SOUND", name:"SE_JUMP", url:"se/jump.mp3"});
			itemlist.push({type:"SOUND", name:"SE_GRAB", url:"se/grab.mp3"});
			itemlist.push({type:"SOUND", name:"SE_BOXCHAKUCHI", url:"se/boxchakuchi.mp3"});
			itemlist.push({type:"SOUND", name:"SE_THROW", url:"se/throw.mp3"});
			itemlist.push({type:"SOUND", name:"SE_SUBERI", url:"se/suberi.mp3"});
			itemlist.push({type:"SOUND", name:"SE_STAGECLEAR", url:"se/stageclear.mp3"});
			itemlist.push({type:"SOUND", name:"SE_ALLCLEAR", url:"se/allclear.mp3"});
			itemlist.push({type:"SOUND", name:"SE_TIMEOUT", url:"se/timeout.mp3"});
			
			changeAction("act_standbyloading");
		}
		
		// --------------------------------//
		// 描画
		// --------------------------------//
		override public function draw():void
		{
			screen.clear();
			
			if(systext != "") {
				var height:int = func_text.getTextHeight("SYSTEM", systext);
				func_text.draw("SYSTEM", screen.buffer, systext, 4, 240-4-height);
			}
		}
		
		// --------------------------------//
		// ローディングに必要なものを読込
		// --------------------------------//
		public function act_standbyloading():void
		{
			if(count == 0) {
				loader.loadBitmap("BMP_SYSFONT", "graphic/sysfont.png");
			}
			
			if(loader.isComplete())
			{
				Database.addItem("BMP_SYSFONT", loader.getContent("BMP_SYSFONT"));
				
				//登録
				var table:String = ""
				 + " ABCDEFGHIJKLMNOPQRSTUVWXYZabcde"
				 + "fghijklmnopqrstuvwxyz0123456789-"
				 + "=\\!@#$%^&*()_+|[]{};:'\",.<>/?`~";
				func_text.addFont("SYSTEM", Database.getItem("BMP_SYSFONT"), table, 6, 8);
				
				if(localconnection.domain == "localhost") {
					changeAction("act_localloading");
				}
				else {
					changeAction("act_networkloading");
				}
			}
		}
		
		// --------------------------------//
		// 各種データ読み込み
		// --------------------------------//
		private var item:Object = null;
		
		//ネットワーク上では１つづつ読み込む
		public function act_networkloading():void
		{
			if(item == null)
			{
				item = itemlist.shift();
				
				systext = "NOWLOADING... "+item.name;
				
				switch(item.type)
				{
				case "SWF":
					loader.loadSWF(item.name, item.url);
					break;
				case "BITMAP":
					loader.loadBitmap(item.name, item.url);
					break;
				case "SOUND":
					loader.loadSound(item.name, item.url);
					break;
				case "XML":
					loader.loadXML(item.name, item.url);
					break;
				case "BINARY":
					loader.loadBinary(item.name, item.url);
					break;
				}
			}
			
			if(loader.isError())
			{
				changeAction("act_error");
				return;
			}
			
			if(loader.isComplete())
			{
				switch(item.type)
				{
				default: Database.addItem(item.name, loader.getContent(item.name)); break;
				case "SOUND": func_se.register(item.name, loader.getContent(item.name)); break;
				}
				
				item = null;
				
				//ロード完了
				if(itemlist.length == 0)
				{
					systext = "WAIT...";
					changeAction("act_complete");
					return;
				}
			}
		}
		
		//ローカルではまとめて読み込む
		public function act_localloading():void
		{
			if(count == 0)
			{
				for each(var item:Object in itemlist)
				{
					switch(item.type)
					{
					case "SWF":
						loader.loadSWF(item.name, item.url);
						break;
					case "BITMAP":
						loader.loadBitmap(item.name, item.url);
						break;
					case "SOUND":
						loader.loadSound(item.name, item.url);
						break;
					case "XML":
						loader.loadXML(item.name, item.url);
						break;
					case "BINARY":
						loader.loadBinary(item.name, item.url);
						break;
					}
				}
			}
			
			if(loader.isError())
			{
				changeAction("act_error");
				return;
			}
				
			if(loader.isComplete())
			{
				for each(var item:* in itemlist)
				{
					switch(item.type)
					{
					default: Database.addItem(item.name, loader.getContent(item.name)); break;
					case "SOUND": func_se.register(item.name, loader.getContent(item.name)); break;
					}
				}
				
				changeAction("act_complete");
				return;
			}
		}
		
		public function act_error():void
		{
			if(count == 0)
			{
				systext = "";
				
				for each(var name:String in loader.getErrorFiles())
				{
					systext += "\nERROR! NOT FOUND - "+name;
				}
			}
		}
		
		public function act_complete():void
		{
			Database.getItem("DAT_STAGE").uncompress();
			
			//登録
			var table:String = " ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-'./㍗";
			func_text.addFont("16x8_blue", Database.getItem("BMP_16X8TEXT_BLUE"), table, 8, 16);
			func_text.addFont("16x8_orange", Database.getItem("BMP_16X8TEXT_ORANGE"), table, 8, 16);
			
			var table:String = ""
			 + " 0123456789ABCDE"
			 + "FGHIJKLMNOPQRSTU"
			 + "VWXYZ_-=+\\|[]()/"
			 + "?!@#%^&*~`:;.,←㍗";
			func_text.addFont("8px", Database.getItem("BMP_8PXTEXT"), table, 8, 8);
			
			changeAction("act_tunefps");
		}
		
		// --------------------------------//
		// FPS調整
		// --------------------------------//
		private var destfps:Number;
		private var pretimer:Number;
		
		public function act_tunefps():void
		{
			if(count == 0)
			{
				destfps = AppInfo.frameRate;
				pretimer = getTimer();
			}
			else if(count % 18 == 0)
			{
				var timer:Number = getTimer()-pretimer;
				systext = "WAIT... "+(1000/destfps*18)+" / "+timer.toString();
				pretimer = getTimer();
				
				if(timer < (1000/destfps*18)-15)	//早すぎる
				{
					AppInfo.frameRate -= 2.5;
				}
				else if(timer > (1000/destfps*18)+30)	//遅すぎる
				{
					AppInfo.frameRate += 5;
				}
				else	//丁度
				{
					systext = "";
					changeAction("act_gotomaingame");
					return;
				}
			}
			
			if(count == 18*16)	//時間切れ
			{
				changeAction("act_gotomaingame");
				return;
			}
		}
		
		// --------------------------------//
		// シーン変更
		// --------------------------------//
		public function act_gotomaingame():void
		{
			changeScene(new InitializeScene());
		}
	}
}