package game.scene
{
	import game.system.SceneBase;
	import game.system.Database;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import game.obj.system.Message;
	import game.obj.system.Picture;
	import game.obj.system.Tile;
	
	public class TitleScene extends SceneBase
	{
		private var title:Picture;
		private var text:Message;
		private var version:Message;
		private var credit:Message;
		
		override public function init():void
		{
			createObject(new BG());
			
			title = createObject(new Picture(Database.getItem("BMP_TITLE")));
			title.x = 160-title.bmp.width/2;
			title.y = 24;
			
			text = createObject(new Message("16x8_blue", "PUSH Z KEY TO START"));
			text.x = 160-text.str.length*4;
			text.y = 168;
			
			version = createObject(new Message("8px", "VER 1.04"));
			version.x = 304-version.str.length*8;
			version.y = 104;
			version.changeDepth("DEPTH_SYSTEM");
			
			credit = createObject(new Message("SYSTEM", "Copyright(C)2006 nemu90kWw. All right reserved."));
			credit.x = 160-credit.str.length*3;
			credit.y = 224;
			
			changeAction("act_main");
		}
		
		public function act_main():void
		{
			if(count % 60 < 40) {text.visible = true;}
			else {text.visible = false;}
			
			if(count > 4) {
				if(func_key.isPress("BTN_A"))
				{
					playSE("SE_START");
					changeAction("act_decide");
				}
			}
		}
		
		public function act_decide():void
		{
			if(count % 4 < 2) {text.visible = true;}
			else {text.visible = false;}
			
			if(count > 25)
			{
				text.vanish();
				version.vanish();
				credit.vanish();
				changeAction_fadeout("act_gotomenu");
			}
		}
		
		public function act_gotomenu():void
		{
			changeScene(new MenuScene());
		}
	}
}

import game.obj.GameObject;
import game.system.Database;
import game.obj.system.Tile;
import flash.geom.ColorTransform;
import flash.display.BitmapData;
import flash.geom.Point;

// --------------------------------//
// 背景
// --------------------------------//
class BG extends GameObject
{
	private var bmp:BitmapData = Database.getItem("BMP_BOXTILE");
	private var bgtile:Tile;
	private var fade:Number = 1.5;
	
	override public function init():void
	{
		registerObject("PRIO_BG", "DEPTH_DISTANT");
		
		bgtile = createObject(new Tile(new BitmapData(bmp.width, bmp.height, false, 0)));
		bgtile.vy = 1/6;
		
		changeAction("act_main");
	}
	
	public function act_main():void
	{
		if(fade >= 0.5)
		{
			bgtile.bmp.copyPixels(bmp, bmp.rect, new Point(0, 0));
			bgtile.bmp.colorTransform(bmp.rect, new ColorTransform(1.5-fade, 1.5-fade, 1.5-fade, 1, 0, 0, 0, 0));
		}
		
		fade /= 1.02;
	}
}
