﻿package game.scene.maingame
{
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import game.system.Database;
	import game.obj.GameObject;
	import game.scene.MainGameScene;
	import game.obj.box.*;
	import game.obj.system.*;
	
	public class MainStage
	{
		public var scene:MainGameScene;
		private var chip:BitmapData;
		public var table:Array;
		private var bglayers:Array = new Array();
		private var chipdatabase:Object = new Object();
		
		public var width:int;
		public var height:int;
		
		private var anmchips:Array = new Array();
		
		public function MainStage()
		{
			for(var i:int = 0; i < 32; i++)
			{
				var chip:ChipInfo = chipdatabase[i] = new ChipInfo();
				
				switch(i)
				{
				case 1: chip.wall = true; break;
				case 2: chip.cloud = true; break;
				case 3:
					chip.wall = true;
					chip.automove = 0.5;
					break;
				case 4:
					chip.wall = true;
					chip.automove = -0.5;
					break;
				}
			}
		}
		
		public function create(course:int, stage:int):void
		{
			chip = Database.getItem("BMP_MAPCHIP"+course).clone();
			
			var anime:BitmapData = Database.getItem("BMP_ANMCHIPS");
			anmchips.push(new AnimationChip(chip, anime, new Rectangle(0, 24, 24, 32), 8, 0, 160, 2));
			anmchips.push(new AnimationChip(chip, anime, new Rectangle(0, 56, 24, 32), 8, 24, 160, 2));
			
			var stagedata:StageData = new StageData(course, stage);
			table = stagedata.table;
			
			width = stagedata.width;
			height = stagedata.height;
			
			var bg1:BGLayer = scene.createObject(new BGLayer("DEPTH_WALL", width, height));
			var bg2:BGLayer = scene.createObject(new BGLayer("DEPTH_WALL_TOP", width, height));
			bg1.setGraphic(chip);
			bg2.setGraphic(chip);
			bglayers.push(bg1);
			bglayers.push(bg2);
			
			//自動整形
			for(var y:int = height-1; y >= 0; y--)
			{
				for(var x:int = 0; x < width; x++)
				{
					var b5:int = getChip(x, y);
					switch(b5)
					{
					case 1:	//壁
						var b8:int = getChip(x, y-1);
						var b2:int = getChip(x, y+1);
						var b4:int = getChip(x-1, y);
						var b6:int = getChip(x+1, y);
						
						if(b8 != 1 && b2 == 1 && b4 != 1 && b6 == 1) {bg1.putChip(16, x, y);bg2.putChip( 8, x, y-1);}
						if(b8 != 1 && b2 == 1 && b4 == 1 && b6 == 1) {bg1.putChip(17, x, y);bg2.putChip( 9, x, y-1);}
						if(b8 != 1 && b2 == 1 && b4 == 1 && b6 != 1) {bg1.putChip(18, x, y);bg2.putChip(10, x, y-1);}
						if(b8 != 1 && b2 == 1 && b4 != 1 && b6 != 1) {bg1.putChip(19, x, y);bg2.putChip(11, x, y-1);}
						if(b8 == 1 && b2 == 1 && b4 != 1 && b6 == 1) {bg1.putChip(24, x, y);}
						if(b8 == 1 && b2 == 1 && b4 == 1 && b6 == 1) {bg1.putChip(25, x, y);}
						if(b8 == 1 && b2 == 1 && b4 == 1 && b6 != 1) {bg1.putChip(26, x, y);}
						if(b8 == 1 && b2 == 1 && b4 != 1 && b6 != 1) {bg1.putChip(27, x, y);}
						if(b8 == 1 && b2 != 1 && b4 != 1 && b6 == 1) {bg1.putChip(32, x, y);}
						if(b8 == 1 && b2 != 1 && b4 == 1 && b6 == 1) {bg1.putChip(33, x, y);}
						if(b8 == 1 && b2 != 1 && b4 == 1 && b6 != 1) {bg1.putChip(34, x, y);}
						if(b8 == 1 && b2 != 1 && b4 != 1 && b6 != 1) {bg1.putChip(35, x, y);}
						if(b8 != 1 && b2 != 1 && b4 != 1 && b6 == 1) {bg1.putChip(40, x, y);bg2.putChip( 8, x, y-1);}
						if(b8 != 1 && b2 != 1 && b4 == 1 && b6 == 1) {bg1.putChip(41, x, y);bg2.putChip( 9, x, y-1);}
						if(b8 != 1 && b2 != 1 && b4 == 1 && b6 != 1) {bg1.putChip(42, x, y);bg2.putChip(10, x, y-1);}
						if(b8 != 1 && b2 != 1 && b4 != 1 && b6 != 1) {bg1.putChip(43, x, y);bg2.putChip(11, x, y-1);}
						break;
					case 2:	//足場
						var b4:int = getChip(x-1, y);
						var b6:int = getChip(x+1, y);
						
						if(b4 == 1 && b6 != 1) {bg2.putChip(20, x, y);bg2.putChip(12, x, y-1);}
						if(b4 != 1 && b6 != 1) {bg2.putChip(21, x, y);bg2.putChip(13, x, y-1);}
						if(b4 != 1 && b6 == 1) {bg2.putChip(22, x, y);bg2.putChip(14, x, y-1);}
						if(b4 == 1 && b6 == 1) {bg2.putChip(23, x, y);bg2.putChip(15, x, y-1);}
						break;
					case 3:	//右コンベア
						bg1.putChip(56, x, y);
						bg2.putChip(48, x, y-1);
						break;
					case 4:	//左コンベア
						bg1.putChip(57, x, y);
						bg2.putChip(49, x, y-1);
						break;
					case 16:	//箱
						table[y][x] = 0;
						createObject(new Box(), x*24 + 12, y*24 + 12);
						break;
					case 17:	//かご
						table[y][x] = 0;
						createObject(new Cage(), x*24 + 12, y*24 + 12);
						break;
					case 18:	//チェックポイント
						table[y][x] = 0;
						createObject(new CheckPoint(), x*24 + 12, y*24 + 12);
						break;
					case 30:	//プレイヤー初期位置（右向き）
						table[y][x] = 0;
						scene.player.stage = this;
						
						scene.player.x = x*24 + 12;
						scene.player.y = y*24 + 25;
						
						scene.player.invert = false;
						scene.player.dir = "RIGHT";
						scene.player.furimuki = 3;
						break;
					case 31:	//プレイヤー初期位置（左向き）
						table[y][x] = 0;
						scene.player.stage = this;
						
						scene.player.x = x*24 + 12;
						scene.player.y = y*24 + 25;
						
						scene.player.invert = true;
						scene.player.dir = "LEFT";
						scene.player.furimuki = -2;
						break;
					}
				}
			}
			
			//遠景
			if(course == 1) {createObject(new BG1(), 0, 0);}
			if(course == 2) {createObject(new BG2(), 0, 0);}
			return;
		}
		
		public function createObject(instance:*, x:Number, y:Number):void
		{
			scene.createObject(instance);
			instance.x = x;
			instance.y = y;
			instance.stage = this;
			return;
		}
		
		public function chip_animation():void
		{
			for each(var c:AnimationChip in anmchips)
			{
				c.main();
			}
			return;
		}
		
		// --------------------------------//
		// 取得関数
		// --------------------------------//
		public function getChip(x:int, y:int):int
		{
			if(y < 0) {y = 0;}
			
			if(y >= table.length) {return 1;}
			if(x < 0 || x >= table[y].length) {return 1;}
			
			return table[y][x];
		}
		
		public function getChipInfo(x:int, y:int):ChipInfo
		{
			return chipdatabase[getChip(x, y)].clone();
		}
		
		public function isFinal(course:int, stage:int):Boolean
		{
			return (course == 1 && stage == 6) || (course == 2 && stage == 8);
		}
	}
}

// --------------------------------//
// 背景
// --------------------------------//
import game.obj.GameObject;
import game.system.Database;
import flash.geom.Rectangle;
import flash.geom.Point;
import flash.display.BitmapData;
import game.obj.system.Tile;
import game.obj.system.Picture;

class BG1 extends GameObject
{
	private var tile:Tile;
	
	override public function init():void
	{
		registerObject("PRIO_BG", "DEPTH_DISTANT");
		
		var temp:BitmapData = Database.getItem("BMP_DISTANT");
		var bmp:BitmapData = new BitmapData(72, 72, false, 0);
		bmp.copyPixels(temp, new Rectangle(0, 0, 72, 72), new Point(0, 0));
		
		tile = createObject(new Tile(bmp), 0, 0);
	}
	
	override public function draw(surface:BitmapData):void
	{
		tile.x = -scene.getCameraX() / 1.5;
		tile.y = -scene.getCameraY() / 1.5;
	}
}

class BG2 extends GameObject
{
	private var tile1:Tile;
	private var tile2:Tile;
	private var sky:Picture;
	
	override public function init():void
	{
		registerObject("PRIO_BG", "DEPTH_DISTANT");
		
		var temp:BitmapData = Database.getItem("BMP_DISTANT");
		
		//そら
		var bmp:BitmapData = new BitmapData(320, 240, false, 0);
		bmp.copyPixels(temp, new Rectangle(0, 72, 320, 240), new Point(0, 0));
		
		sky = createObject(new Picture(bmp, "DEPTH_DISTANT"), 0, 0);
		
		//鉄骨
		var bmp:BitmapData = new BitmapData(72, 72, true, 0);
		bmp.copyPixels(temp, new Rectangle(72, 0, 72, 72), new Point(0, 0));
		
		tile1 = createObject(new Tile(bmp), 0, 0);
		tile1.margin_y = 120;
		tile2 = createObject(new Tile(bmp), 0, 0);
		tile2.margin_y = 120;
	}
	
	override public function draw(surface:BitmapData):void
	{
		tile1.x = -scene.getCameraX() / 2 - count/2;
		tile1.y = -scene.getCameraY() / 2;
		
		tile2.x = -scene.getCameraX() / 2 + count/2;
		tile2.y = -scene.getCameraY() / 2 + 96;
	}
}
