package game.scene.maingame
{
	import game.system.Database;
	import flash.utils.ByteArray;
	
	public class StageData
	{
		public var table:Array;
		public var width:int;
		public var height:int;
		
		public function StageData(course:int, stage:int)
		{
			var bin:ByteArray = Database.getItem("DAT_STAGE");
			bin.position = 0;
			
			table = StageEncoder.decode(bin.readObject()[course+"-"+stage]);
			
			width = table[0].length;
			height = table.length;
		}
	}
}

import flash.utils.ByteArray;

class StageEncoder
{
	public static function encode(table:Array):ByteArray
	{
		var bin:ByteArray = new ByteArray();
		
		bin.writeByte(table[0].length);	//width
		bin.writeByte(table.length);	//height
		
		for(var y:int = 0; y < table.length; y++)
		{
			for(var x:int = 0; x < table[y].length; x++)
			{
				bin.writeByte(table[y][x]);
			}
		}
		
		return bin;
	}
	
	public static function decode(bin:ByteArray):Array
	{
		var table:Array = new Array();
		
		bin.position = 0;
		
		var width:int = bin.readByte();
		var height:int = bin.readByte();
		
		for(var y:int = 0; y < height; y++)
		{
			table[y] = new Array();
			
			for(var x:int = 0; x < width; x++)
			{
				table[y].push(bin.readByte());
			}
		}
		
		return table;
	}
}
