package game.system
{
	import flash.display.BitmapData;
	import flash.geom.Matrix;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	
	public class Graphic
	{
		private var bmp_normal:BitmapData;
		private var bmp_invert:BitmapData;
		private var frames:Object = new Object();
		
		public var width:int;
		public var height:int;
		
		public function Graphic(bmp:BitmapData)
		{
			width  = bmp.width;
			height = bmp.height;
			
			bmp_normal = bmp;
			bmp_invert = new BitmapData(width, height, bmp.transparent, 0);
			
			//左右反転したものを格納
			var matrix:Matrix = new Matrix();
			matrix.scale(-1.0, 1.0);
			matrix.translate(width, 0);
			bmp_invert.draw(bmp, matrix);
		}
		
		public function addFrame(label:String, rect:Rectangle, cx:int = 0, cy:int = 0):void
		{
			frames[label] = new FrameInfo(bmp_normal, rect, cx, cy);
		}
		
		public function draw(surface:BitmapData, label:String, x:int, y:int, invert:Boolean = false):void
		{
			if(label == "") {return;}
			
			if(invert == false) {
				surface.copyPixels(
					bmp_normal,
					frames[label].rect_normal,
					new Point(x-frames[label].cx_normal, y-frames[label].cy)
				);
			}
			else {
				surface.copyPixels(
					bmp_invert,
					frames[label].rect_invert,
					new Point(x-frames[label].cx_invert, y-frames[label].cy)
				);
			}
		}
	}
}

import flash.geom.Rectangle;
import flash.display.BitmapData;

class FrameInfo
{
	public var rect_normal:Rectangle;
	public var rect_invert:Rectangle;
	public var cx_normal:int = 0;
	public var cx_invert:int = 0;
	public var cy:int = 0;
	
	public function FrameInfo(bmp:BitmapData, rect:Rectangle, cx:int, cy:int)
	{
		rect_normal = rect;
		rect_invert = rect.clone();
		rect_invert.x = bmp.width - rect.x - rect.width;
		
		cx_normal = cx;
		cx_invert = rect.width - cx;
		
		this.cy = cy;
	}
}
