package game.system
{
	import common.LocalDataManager;
	
	public class Option
	{
		private var func_ldm:LocalDataManager = new LocalDataManager("option");
		public var data:Array = new Array();
		
		public function Option()
		{
			data.fps = "";
			func_ldm.setDefault("fps", "OFF");
		}
		
		// --------------------------------//
		// 初期化
		// --------------------------------//
		public function initialize():void
		{
			func_ldm.initialize();
			
			for(var i:String in data)
			{
				data[i] = func_ldm.getDefault(i);
			}
			
			return;
		}
		
		// --------------------------------//
		// 保存
		// --------------------------------//
		public function saveData():void
		{
			for(var i:String in data)
			{
				func_ldm.saveData(i, data[i]);
			}
			
			return;
		}
		
		// --------------------------------//
		// ローカルデータから読み込み
		// --------------------------------//
		public function loadData():void
		{
			for(var i:String in data)
			{
				data[i] = func_ldm.loadData(i);
			}
			
			return;
		}
		
		// --------------------------------//
		// チェック
		// --------------------------------//
		public function isEmpty():Boolean
		{
			return func_ldm.isEmpty();
		}
		
		public function isError():Boolean
		{
			return func_ldm.isError();
		}
	}
}
