package game.system
{
	import common.Screen;
	import game.obj.GameObject;
	import game.obj.system.FadeOut;
	
	public class SceneBase extends ObjBase
	{
		public var screen:Screen;
		
		protected var camera_x:Number = 0;
		protected var camera_y:Number = 0;
		
		public var func_key:KeyWatcher;
		public var func_obj:ObjectManager;
		internal var func_scene:SceneController;
		
		private var fadeout_nextaction:String;
		
		public function changeScene(scene:SceneBase):void {func_scene.changeScene(scene);}
		
		public function endScene():void
		{
			return;
		}
		
		public function createObject(instance:GameObject):*
		{
			instance.func_key = func_key;
			instance.scene = this;
			instance.init();
			return instance;
		}
		
		public function getCameraX():Number
		{
			return Math.floor(camera_x);
		}
		
		public function getCameraY():Number
		{
			return Math.floor(camera_y);
		}
		
		public function act_fadeout():void
		{
			if(count == 28)
			{
				changeAction(fadeout_nextaction);
				super.main();
				return;
			}
			
			return;
		}
		
		public function changeAction_fadeout(func:String):void
		{
			createObject(new FadeOut());
			changeAction("act_fadeout");
			fadeout_nextaction = func;
			return;
		}
		
		// --------------------------------//
		// 共通関数
		// --------------------------------//
		override public function main():void
		{
			func_obj.run();
			
			super.main();
			return;
		}
		
		public function draw():void
		{
			func_obj.draw();
			return;
		}
	}
}